/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */


extern int get5(void);
extern void setVolatileRegisters(void);
extern int testNonVolatiles(float (*func)(float, float, float, float, float, float, float, float));

struct skipStruct {
  int data[4*69];
};


extern int testSimpleParmPassing1(unsigned char, unsigned short, unsigned int, float, 
				  unsigned long long, double, vector unsigned int, long int,
				  unsigned char, unsigned short, unsigned int, float, 
				  unsigned long long, double, vector unsigned int, long int);

extern int testSimpleParmPassing2(struct skipStruct skip, 
				  unsigned char, unsigned short, unsigned int, float, 
				  unsigned long long, double, vector unsigned int, long int,
				  unsigned char, unsigned short, unsigned int, float, 
				  unsigned long long, double, vector unsigned int, long int);

struct parmPassing {
  unsigned char a;
  unsigned short b;
  unsigned int c;
  float d;
  unsigned long long e;
  double f;
  vector unsigned int g;
  long int h;
};

extern int testStructParmPassing1(unsigned short, struct parmPassing,
				  unsigned int, struct parmPassing, unsigned char);

extern int testStructParmPassing2(struct skipStruct skip, unsigned short, struct parmPassing,
				  unsigned int, struct parmPassing, unsigned char);

extern int testStructParmPassing3(struct skipStruct skip1, struct skipStruct skip2, unsigned short, struct parmPassing,
				  unsigned int, struct parmPassing, unsigned char);


struct retSmall {
  unsigned int a;
  unsigned char b;
  unsigned short c;
  unsigned char d;
  float e;
};

struct retLarge1 {
  unsigned char a;
  vector unsigned int b[70];
  int c;
};

struct retLarge2 {
  unsigned char a;
  vector unsigned int b[71];
  int c;
};

struct retUChar {
  unsigned char a;
};


extern int testReturnUChar(unsigned char (*func)(void));
extern int testReturnUShort(unsigned short (*func)(void));
extern int testReturnUInt(unsigned int (*func)(void));
extern int testReturnULongLong(unsigned long long (*func)(void));
extern int testReturnFloat(float (*func)(void));
extern int testReturnDouble(double (*func)(void));
extern int testReturnStruct(struct retSmall (*func)(void));
extern int testReturnVector(vector unsigned int (*func)(void));
extern int testReturnUCharStruct(struct retUChar (*func)(void));
extern int testReturnLargeStruct1(struct retLarge1 (*func)(vector unsigned int));
extern int testReturnLargeStruct2(struct retLarge2 (*func)(vector unsigned int));

extern int testVarArgsAll(float, ...);
extern int testVarArgsStruct(unsigned int, ...);
extern int testVarArgsMost1(unsigned int, float, float, unsigned short, ...);
extern int testVarArgsMost2(struct skipStruct skip, unsigned int, float, float, unsigned short, ...);

struct stackData {
  vector unsigned int lr;
  vector unsigned int sp;
  vector unsigned int toc;
}; 

extern struct stackData currentSD;

extern void saveStackData();
