# --------------------------------------------------------------  
# (C)Copyright 2001,2007,                                         
# International Business Machines Corporation,                    
# Sony Computer Entertainment, Incorporated,                      
# Toshiba Corporation,                                            
#                                                                 
# All Rights Reserved.                                            
#                                                                 
# Redistribution and use in source and binary forms, with or      
# without modification, are permitted provided that the           
# following conditions are met:                                   
#                                                                 
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer. 
#                                                                 
# - Redistributions in binary form must reproduce the above       
#   copyright notice, this list of conditions and the following   
#   disclaimer in the documentation and/or other materials        
#   provided with the distribution.                               
#                                                                 
# - Neither the name of IBM Corporation nor the names of its      
#   contributors may be used to endorse or promote products       
#   derived from this software without specific prior written     
#   permission.                                                   
#                                                                 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              
# --------------------------------------------------------------  
# PROLOG END TAG zYx                                              
# 
# This file contains an SPU assembly coverage test. It attempts to
# verify that the syntaxes specified in the SPU assmbly Language Reference
# are supported by the assembler. Note, this test does nothing
# to verify that the instructions are correctly encoded. However, one
# can disassemble the objects and visually scan for errors.
	
	.text
	.global _start

_start:
	# Verify that all the instructions are recognized
		
	a $1, $2, $3		# 0
	absdb $1, $2, $3
	addx $1, $2, $3
	ah $1, $2, $3
	ahi $1, $2, -1
	ai $1, $2, -1
	and $1, $2, $3
	andbi $1, $2, -1
	andc $1, $2, $3
	andhi $1, $2, -1
	andi $1, $2, -1		# 10
	avgb $1, $2, $3
	bg $1, $2, $3
	bgx $1, $2, $3
	bi $1
	bid $1
	bie $1
	bihnz $1, $2
	bihnzd $1, $2
	bihnze $1, $2
	bihz $1, $2		# 20
	bihzd $1, $2
	bihze $1, $2
	binz $1, $2
	binzd $1, $2
	binze $1, $2
	bisl $1, $2
	bisld $1, $2
	bisle $1, $2
	bisled $1, $2
	bisledd $1, $2		# 30
	bislede $1, $2
	biz $1, $2
	bizd $1, $2
	bize $1, $2
	br -20
	bra 20
	brasl $1, 20
	brhnz $1, 20
	brhz $1, 20
	brnz $1, 20		# 40
	brsl $1, 20
	brz $1, 20
	cbd $1, 7($2)
	cbx $1, $2, $3
	cdd $1, 7($2)
	cdx $1, $2, $3
	ceq $1, $2, $3
	ceqb $1, $2, $3
	ceqbi $1, $2, -1
	ceqh $1, $2, $3		# 50
	ceqhi $1, $2, -1
	ceqi $1, $2, -1
	cflts $1, $2, 3
	cfltu $1, $2, 3
	cg $1, $2, $3
	cgt $1, $2, $3
	cgtb $1, $2, $3
	cgtbi $1, $2, -1
	cgth $1, $2, $3
	cgthi $1, $2, -1	# 60
	cgti $1, $2, -1
	cgx $1, $2, $3
	chd $1, 7($2)
	chx $1, $2, $3
	clgt $1, $2, $3
	clgtb $1, $2, $3
	clgtbi $1, $2, -1
	clgth $1, $2, $3
	clgthi $1, $2, -1
	clgti $1, $2, -1	# 70
	clz $1, $2
	cntb $1, $2
	csflt $1, $2, 3
	cuflt $1, $2, 3
	cwd $1, 7($2)
	cwx $1, $2, $3
	dfa $1, $2, $3
	dfm $1, $2, $3
	dfma $1, $2, $3
	dfms $1, $2, $3		# 80
	dfnma $1, $2, $3
	dfnms $1, $2, $3
	dfs $1, $2, $3
	dsync
	eqv $1, $2, $3
	fa $1, $2, $3
	fceq $1, $2, $3
	fcgt $1, $2, $3
	fcmeq $1, $2, $3
	fcmgt $1, $2, $3	# 90
	fesd $1, $2
	fi $1, $2, $3
	fm $1, $2, $3
	fma $1, $2, $3, $4
	fms $1, $2, $3, $4
	fnms $1, $2, $3, $4
	frds $1, $2
	frest $1, $2
	frsqest $1, $2
	fs $1, $2, $3		# 100
	fscrrd $1
	fscrwr $1
	fscrwr $1, $2
	fsm $1, $2
	fsmb $1, $2
	fsmbi $1, 16
	fsmh $1, $2
	gb $1, $2
	gbb $1, $2
	gbh $1, $2		# 110
	hbr -12, $2
	hbra -12, 20
	hbrp
	hbrr -12, -20
	heq $1, $2
	heq $1, $2, $3
	heqi $1, -10
	heqi $1, $2, -1
	hgt $1, $2
	hgt $1, $2, $3		# 120
	hgti $1, -10
	hgti $1, $2, -1
	hlgt $1, $2
	hlgt $1, $2, $3
	hlgti $1, -10
	hlgti $1, $2, -1
	il $1, -16
	ila $1, 16
	ilh $1, 16
	ilhu $1, 16		# 130
	iohl $1, 16
	iretd
	iretd $1
	irete
	irete $1
	iret
	iret $1
	lnop
	lqa $1, 20
	lqd $1, -32($2)		# 140
	lqr $1, -20
	lqx $1, $2, $3
	mfspr $1, $0
	mpy $1, $2, $3
	mpya $1, $2, $3, $4
	mpyh $1, $2, $3
	mpyhh $1, $2, $3
	mpyhha $1, $2, $3
	mpyhhau $1, $2, $3
	mpyhhu $1, $2, $3	# 150
	mpyi $1, $2, -1
	mpys $1, $2, $3
	mpyu $1, $2, $3
	mpyui $1, $2, -1
	mtspr $0, $2
	nand $1, $2, $3
	nop
	nop $1
	nor $1, $2, $3
	or $1, $2, $3		# 160
	orbi $1, $2, -1
	orc $1, $2, $3
	orhi $1, $2, -1
	ori $1, $2, -1
	orx $1, $2		# DD 2.0
	rchcnt $1, $ch2
	rdch $1, $ch2
	rot $1, $2, $3
	roth $1, $2, $3
	rothi $1, $2, -7	# 170
	rothm $1, $2, $3
	rothmi $1, $2, -6
	roti $1, $2, -7
	rotm $1, $2, $3
	rotma $1, $2, $3
	rotmah $1, $2, $3
	rotmahi $1, $2, -6
	rotmai $1, $2, -7
	rotmi $1, $2, -7
	rotqbi $1, $2, $3	# 180
	rotqbii $1, $2, 3
	rotqby $1, $2, $3
	rotqbybi $1, $2, $3
	rotqbyi $1, $2, -7
	rotqmbi $1, $2, $3
	rotqmbii $1, $2, -3
	rotqmby $1, $2, $3
	rotqmbybi $1, $2, $3
	rotqmbyi $1, $2, -6
	selb $1, $2, $3, $4	# 190
	sf $1, $2, $3
	sfh $1, $2, $3
	sfhi $1, $2, -1
	sfi $1, $2, -1
	sfx $1, $2, $3
	shl $1, $2, $3
	shlh $1, $2, $3
	shlhi $1, $2, 5
	shli $1, $2, 6
	shlqbi $1, $2, $3	# 200
	shlqbii $1, $2, 3
	shlqby $1, $2, $3
	shlqbybi $1, $2, $3
	shlqbyi $1, $2, 5
	shufb $1, $2, $3, $4
	stop 14
	stqa $1, 20
	stqd $1, -32($2)
	stqr $1, -20
	stqx $1, $2, $3		# 210
	sumb $1, $2, $3
	sync
	syncc
	wrch $ch1, $2
	xor $1, $2, $3
	xorbi $1, $2, -1
	xorhi $1, $2, -1
	xori $1, $2, -1
	xsbh $1, $2
	xshw $1, $2		# 220
	xswd $1, $2

	# Boundary test the range of operands. This includes:
	# registers, channels, and immediate constants.
	
	# Min and Max register
	a $0, $1, $2
	a $125, $126, $127		
	
	# Min and Max channel number
	rdch $1, $ch0
	rchcnt $1, $ch0
	wrch $ch0, $1
	rdch $1, $ch127
	rchcnt $1, $ch127
	wrch $ch127, $1
	
	# Min and Max s3
	rotqmbii $3, $3, 0xAAAAAAAA	# 230
	rotqmbii $3, $3, 0x55555555
	
	# Min and Max s6
	rothmi $6, $6, -31
	rotmahi $6, $6, -31
	rotqmbyi $6, $6, -31
	rothmi $6, $6, 0
	rotmahi $6, $6, 0
	rotqmbyi $6, $6, 0

	# Min and Max s7
	rothi $7, $7, 0xAAAAAAAA
	roti $7, $7, 0xAAAAAAAA
	rotqbyi $7, $7, 0xAAAAAAAA	# 240
	rothi $7, $7, 0x55555555
	roti $7, $7, 0x55555555
	rotqbyi $7, $7, 0x55555555
	
	rotmai $7, $7, -63
	rotmi $7, $7, -63
	rotmai $7, $7, 0
	rotmi $7, $7, 0
	
	# Min and Max s10
	ahi $10, $10, -512
	ai $10, $10, -512
	andhi $10, $10, -512		# 250
	andi $10, $10, -512
	ceqhi $10, $10, -512
	ceqi $10, $10, -512
	cgthi $10, $10, -512
	cgti $10, $10, -512
	clgthi $10, $10, -512
	clgti $10, $10, -512
	heqi $10, -512
	heqi $10, $10, -512
	hgti $10, -512			# 260
	hgti $10, $10, -512
	hlgti $10, -512
	hlgti $10, $10, -512
	mpyi $10, $10, -512
	mpyui $10, $10, -512
	orhi $10, $10, -512
	ori $10, $10, -512
	sfhi $10, $10, -512
	sfi $10, $10, -512
	xorhi $10, $10, -512		# 270
	xori $10, $10, -512
	
	ahi $10, $10, 511
	ai $10, $10, 511
	andhi $10, $10, 511
	andi $10, $10, 511
	ceqhi $10, $10, 511
	ceqi $10, $10, 511
	cgthi $10, $10, 511
	cgti $10, $10, 511
	clgthi $10, $10, 511		# 280
	clgti $10, $10, 511
	heqi $10, 511
	heqi $10, $10, 511
	hgti $10, 511
	hgti $10, $10, 511
	hlgti $10, 511
	hlgti $10, $10, 511
	mpyi $10, $10, 511
	mpyui $10, $10, 511
	orhi $10, $10, 511		# 290
	ori $10, $10, 511
	sfhi $10, $10, 511
	sfi $10, $10, 511
	xorhi $10, $10, 511
	xori $10, $10, 511

	andbi $10, $10, -128
	ceqbi $10, $10, -128
	cgtbi $10, $10, -128
	clgtbi $10, $10, -128
	orbi $10, $10, -128		# 300
	xorbi $10, $10, -128

	andbi $10, $10, 255
	ceqbi $10, $10, 255
	cgtbi $10, $10, 255
	clgtbi $10, $10, 255
	orbi $10, $10, 255
	xorbi $10, $10, 255
	
	
	# Min and Max s11
	hbr -1024, $11
	hbra -1024, 8
	hbrp				# 310
	hbrr -1024, 8
	
	hbr 1020, $11
	hbra 1020, 8
	hbrp
	hbrr 1020, 8	
	
	# Min and Max s14
	lqd $14, -8192($14)
	stqd $14, -8192($14)
	
	lqd $14, 8176($14)
	stqd $14, 8176($14)
	
	# Min and Max s16
	il $16, -32768			# 320
	il $16, -32768
	il $16, 32767
	il $16, 32767

	# Min and Max s18
	br -131072
	bra -131072
	brasl $18, -131072
	brhnz $18, -131072
	brhz $18, -131072
	brnz $18, -131072
	brsl $18, -131072		# 330
	brz $18, -131072
	hbra 12, -131072
	hbrr 12, -131072
	lqa $18, -131072
	lqr $18, -131072
	stqa $18, -131072
	stqr $18, -131072

	br 131068
	bra 131068
	brasl $18, 131068		# 340
	brhnz $18, 131068
	brhz $18, 131068
	brnz $18, 131068
	brsl $18, 131068
	brz $18, 131068
	hbra 12, 131068
	hbrr 12, 131068
	lqa $18, 131068
	lqr $18, 131068
	stqa $18, 131068		# 350
	stqr $18, 131068

	# Min and Max scale
	cflts $0, $0, 0
	cfltu $0, $0, 0
	csflt $0, $0, 0
	cuflt $0, $0, 0
	
	cflts $0, $0, 127
	cfltu $0, $0, 127
	csflt $0, $0, 127
	cuflt $0, $0, 127
	
	# Min and Max u3
	rotqbii $3, $3, 0x0		# 360
	shlqbii $3, $3, 0x0
	
	rotqbii $3, $3, 0x89ABCDEF
	shlqbii $3, $3, 0x7
	

	# Min and Max u5
	shlhi $5, $5, 0
	shlqbyi $5, $5, 0
	shlhi $5, $5, 31
	shlqbyi $5, $5, 31

	# Min and Max u6
	shli $6, $6, 0
	shli $6, $6, 63

	# Min and Max u7
	cbd $7, 0x89ABCDEF($7)		# 370
	cdd $7, 0x89ABCDEF($7)
	chd $7, 0x89ABCDEF($7)
	cwd $7, 0x89ABCDEF($7)

	cbd $7, 1($7)
	cdd $7, 1($7)
	chd $7, 1($7)
	cwd $7, 1($7)
		
	# Min and Max u14
	stop 0
	stop 16383

	# Min and Max u16
	fsmbi $16, 0			# 380
	ilh $16, 0
	ilhu $16, 0
	iohl $16, 0

	fsmbi $16, 0xFFFF
	ilh $16, 0xFFFF
	ilhu $16, 0xFFFF
	iohl $16, 0xFFFF

	# Min and Max u18
	ila $18, 0x0
	ila $18, 0x3FFFF
	
	# Verify register aliases
	il $LR, 0			# 390	
	il $SP, 0
	
	# Verify instruction aliases
	lr $1, $2
		
	# Verify channel mnemonics - generic, spu, and mfc.
	
	# Generic channels
	rdch $1, $ch0
	rdch $1, $ch1
	rdch $1, $ch2
	rdch $1, $ch3
	rdch $1, $ch4
	rdch $1, $ch5
	rdch $1, $ch6
	rdch $1, $ch7			# 400
	rdch $1, $ch8
	rdch $1, $ch9
	rdch $1, $ch10
	rdch $1, $ch11
	rdch $1, $ch12
	rdch $1, $ch13
	rdch $1, $ch14
	rdch $1, $ch15
	rdch $1, $ch16
	rdch $1, $ch17			# 410
	rdch $1, $ch18
	rdch $1, $ch19
	rdch $1, $ch20
	rdch $1, $ch21
	rdch $1, $ch22
	rdch $1, $ch23
	rdch $1, $ch24
	rdch $1, $ch25
	rdch $1, $ch26
	rdch $1, $ch27			# 420
	rdch $1, $ch28
	rdch $1, $ch29
	rdch $1, $ch30
	rdch $1, $ch31
	rdch $1, $ch32
	rdch $1, $ch33
	rdch $1, $ch34
	rdch $1, $ch35
	rdch $1, $ch36
	rdch $1, $ch37			# 430
	rdch $1, $ch38
	rdch $1, $ch39
	rdch $1, $ch40
	rdch $1, $ch41
	rdch $1, $ch42
	rdch $1, $ch43
	rdch $1, $ch44
	rdch $1, $ch45
	rdch $1, $ch46
	rdch $1, $ch47			# 440
	rdch $1, $ch48
	rdch $1, $ch49
	rdch $1, $ch50
	rdch $1, $ch51
	rdch $1, $ch52
	rdch $1, $ch53
	rdch $1, $ch54
	rdch $1, $ch55
	rdch $1, $ch56
	rdch $1, $ch57			# 450
	rdch $1, $ch58
	rdch $1, $ch59
	rdch $1, $ch60
	rdch $1, $ch61
	rdch $1, $ch62
	rdch $1, $ch63
	rdch $1, $ch64
	rdch $1, $ch65
	rdch $1, $ch66
	rdch $1, $ch67			# 460
	rdch $1, $ch68
	rdch $1, $ch69
	rdch $1, $ch70
	rdch $1, $ch71
	rdch $1, $ch72
	rdch $1, $ch73
	rdch $1, $ch74
	rdch $1, $ch75
	rdch $1, $ch76
	rdch $1, $ch77			# 470
	rdch $1, $ch78
	rdch $1, $ch79
	rdch $1, $ch80
	rdch $1, $ch81
	rdch $1, $ch82
	rdch $1, $ch83
	rdch $1, $ch84
	rdch $1, $ch85
	rdch $1, $ch86
	rdch $1, $ch87			# 480
	rdch $1, $ch88
	rdch $1, $ch89
	rdch $1, $ch90
	rdch $1, $ch91
	rdch $1, $ch92
	rdch $1, $ch93
	rdch $1, $ch94
	rdch $1, $ch95
	rdch $1, $ch96
	rdch $1, $ch97			# 490
	rdch $1, $ch98
	rdch $1, $ch99
	rdch $1, $ch100
	rdch $1, $ch101
	rdch $1, $ch102
	rdch $1, $ch103
	rdch $1, $ch104
	rdch $1, $ch105
	rdch $1, $ch106
	rdch $1, $ch107			# 500
	rdch $1, $ch108
	rdch $1, $ch109
	rdch $1, $ch110
	rdch $1, $ch111
	rdch $1, $ch112
	rdch $1, $ch113
	rdch $1, $ch114
	rdch $1, $ch115
	rdch $1, $ch116
	rdch $1, $ch117			# 510
	rdch $1, $ch118
	rdch $1, $ch119
	rdch $1, $ch120
	rdch $1, $ch121
	rdch $1, $ch122
	rdch $1, $ch123
	rdch $1, $ch124
	rdch $1, $ch125
	rdch $1, $ch126
	rdch $1, $ch127			# 520
	
	# SPU channels
	
	rdch $2, $SPU_RdEventStat
	rdch $2, $SPU_RdDec
	rdch $2, $SPU_RdMachStat
	rdch $2, $SPU_RdSRR0
	
	rdch $2, $SPU_RdEventMask

 	wrch $SPU_WrEventMask, $3
	wrch $SPU_WrEventAck, $3
	wrch $SPU_WrDec, $3
	wrch $SPU_WrSRR0, $3
	wrch $ch64, $3	# 530
	
	# MFC channels
	rdch $4, $SPU_RdSigNotify1
	rdch $4, $SPU_RdSigNotify2
	rdch $4, $MFC_RdTagStat
	rdch $4, $MFC_RdListStallStat
	rdch $4, $MFC_RdAtomicStat
	rdch $4, $SPU_RdInMbox
	
	rdch $4, $MFC_RdTagMask	# DD 2.0
	
	wrch $MFC_LSA, $5
	wrch $MFC_EAH, $5
	wrch $MFC_EAL, $5		# 540
	wrch $MFC_Size, $5
	wrch $MFC_TagID, $5
	wrch $MFC_Cmd, $5
	wrch $MFC_WrTagMask, $5
	wrch $MFC_WrTagUpdate, $5
	wrch $MFC_WrListStallAck, $5
	wrch $SPU_WrOutMbox, $5
	wrch $SPU_WrOutIntrMbox, $5

	# Verify styles of immediate values - relative, constants, and symbolic.
backward:		
	br	.-16
	br	backward		# 550
	br	forward

	# Verify optional parameters
	stop
	
	# Verify high and low address selection specification

	ilhu	$3, backward@h
	iohl	$3, backward@l
	
	# Verify enhanced double precision instructions.
	dfceq	$3, $4, $5
	dfcgt	$3, $4, $5
	dfcmeq	$3, $4, $5
	dfcmgt	$3, $4, $5
	dftsv   $8, $9, 0
	dftsv   $8, $9, 27
	dftsv	$8, $9, 127

forward:		
	stopd	$100, $32, $17

