/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#include <stdio.h>


/* verify_coverage attempts to verify that a success assembly of the
 * assembler coverage test (spu/coverage.s) produced the correct bin
 * output.
 */

unsigned int expected[] = {
  0x1800c101,
  0x0a60c101,
  0x6800c101,
  0x1900c101,
  0x1dffc101,
  0x1cffc101,
  0x1820c101,
  0x16ffc101,
  0x5820c101,
  0x15ffc101,
  0x14ffc101,
  0x1a60c101,
  0x0840c101,
  0x6860c101,
  0x35000080,
  0x35080080,
  0x35040080,
  0x25600101,
  0x25680101,
  0x25640101,
  0x25400101,
  0x25480101,
  0x25440101,
  0x25200101,
  0x25280101,
  0x25240101,
  0x35200101,
  0x35280101,
  0x35240101,
  0x35600101,
  0x35680101,
  0x35640101,
  0x25000101,
  0x25080101,
  0x25040101,
  0x327ffd80,
  0x30000280,
  0x31000281,
  0x23000281,
  0x22000281,
  0x21000281,
  0x33000281,
  0x20000281,
  0x3e81c101,
  0x3a80c101,
  0x3ee1c101,
  0x3ae0c101,
  0x7800c101,
  0x7a00c101,
  0x7effc101,
  0x7900c101,
  0x7dffc101,
  0x7cffc101,
  0x762A8101,
  0x766A8101,
  0x1840c101,
  0x4800c101,
  0x4a00c101,
  0x4effc101,
  0x4900c101,
  0x4dffc101,
  0x4cffc101,
  0x6840c101,
  0x3ea1c101,
  0x3aa0c101,
  0x5800c101,
  0x5a00c101,
  0x5effc101,
  0x5900c101,
  0x5dffc101,
  0x5cffc101,
  0x54a00101,
  0x56800101,
  0x76A60101,
  0x76E60101,
  0x3ec1c101,
  0x3ac0c101,
  0x5980c101,
  0x59c0c101,
  0x6b80c101,
  0x6ba0c101,
  0x6be0c101,
  0x6bc0c101,
  0x59a0c101,
  0x00600000,
  0x4920c101,
  0x5880c101,
  0x7840c101,
  0x5840c101,
  0x7940c101,
  0x5940c101,
  0x77000101,
  0x7a80c101,
  0x58c0c101,
  0xe020c104,
  0xf020c104,
  0xd020c104,
  0x77200101,
  0x37000101,
  0x37200101,
  0x58a0c101,
  0x73000001,
  0x77400080,
  0x77400101,
  0x36800101,
  0x36c00101,
  0x32800801,
  0x36a00101,
  0x36000101,
  0x36400101,
  0x36200101,
  0x3580c17d,
  0x118002fd,
  0x35900000,
  0x13fffdfd,
  0x7b008080,
  0x7b00c101,
  0x7ffd8080,
  0x7fffc101,
  0x4b008080,
  0x4b00c101,
  0x4ffd8080,
  0x4fffc101,
  0x5b008080,
  0x5b00c101,
  0x5ffd8080,
  0x5fffc101,
  0x40fff801,
  0x42000801,
  0x41800801,
  0x41000801,
  0x60800801,
  0x35480000,
  0x35480080,
  0x35440000,
  0x35440080,
  0x35400000,
  0x35400080,
  0x00200000,
  0x30800281,
  0x34ff8101,
  0x33fffd81,
  0x3880c101,
  0x01800001,
  0x7880c101,
  0xc020c104,
  0x78a0c101,
  0x78c0c101,
  0x68c0c101,
  0x69c0c101,
  0x79c0c101,
  0x74ffc101,
  0x78e0c101,
  0x7980c101,
  0x75ffc101,
  0x21800002,
  0x1920c101,
  0x40200000,
  0x40200001,
  0x0920c101,
  0x0820c101,
  0x06ffc101,
  0x5920c101,
  0x05ffc101,
  0x04ffc101,
  0x3e000101,
  0x01e00101,
  0x01a00101,
  0x0b00c101,
  0x0b80c101,
  0x0f9e4101,
  0x0ba0c101,
  0x0fbe8101,
  0x0f1e4101,
  0x0b20c101,
  0x0b40c101,
  0x0bc0c101,
  0x0fde8101,
  0x0f5e4101,
  0x0f3e4101,
  0x3b00c101,
  0x3f00c101,
  0x3b80c101,
  0x3980c101,
  0x3f9e4101,
  0x3b20c101,
  0x3f3f4101,
  0x3ba0c101,
  0x39a0c101,
  0x3fbe8101,
  0x8020c104,
  0x0800c101,
  0x0900c101,
  0x0dffc101,
  0x0cffc101,
  0x6820c101,
  0x0b60c101,
  0x0be0c101,
  0x0fe14101,
  0x0f618101,
  0x3b60c101,
  0x3f60c101,
  0x3be0c101,
  0x39e0c101,
  0x3fe14101,
  0xb020c104,
  0x0000000e,
  0x20800281,
  0x24ff8101,
  0x23fffd81,
  0x2880c101,
  0x4a60c101,
  0x00400000,
  0x00500000,
  0x21a00082,
  0x4820c101,
  0x46ffc101,
  0x45ffc101,
  0x44ffc101,
  0x56c00101,
  0x55c00101,
  0x54c00101,
  0x18008080,
  0x181fff7d,
  0x01a00001,
  0x01e00001,
  0x21a00001,
  0x01a03f81,
  0x01e03f81,
  0x21a03f81,
  0x3f2a8183,
  0x3f354183,
  0x0fb84306,
  0x0fd84306,
  0x3fb84306,
  0x0fa00306,
  0x0fc00306,
  0x3fa00306,
  0x0f8a8387,
  0x0f0a8387,
  0x3f8a8387,
  0x0f954387,
  0x0f154387,
  0x3f954387,
  0x0f504387,
  0x0f304387,
  0x0f400387,
  0x0f200387,
  0x1d80050a,
  0x1c80050a,
  0x1580050a,
  0x1480050a,
  0x7d80050a,
  0x7c80050a,
  0x4d80050a,
  0x4c80050a,
  0x5d80050a,
  0x5c80050a,
  0x7f800500,
  0x7f80050a,
  0x4f800500,
  0x4f80050a,
  0x5f800500,
  0x5f80050a,
  0x7480050a,
  0x7580050a,
  0x0580050a,
  0x0480050a,
  0x0d80050a,
  0x0c80050a,
  0x4580050a,
  0x4480050a,
  0x1d7fc50a,
  0x1c7fc50a,
  0x157fc50a,
  0x147fc50a,
  0x7d7fc50a,
  0x7c7fc50a,
  0x4d7fc50a,
  0x4c7fc50a,
  0x5d7fc50a,
  0x5c7fc50a,
  0x7f7fc500,
  0x7f7fc50a,
  0x4f7fc500,
  0x4f7fc50a,
  0x5f7fc500,
  0x5f7fc50a,
  0x747fc50a,
  0x757fc50a,
  0x057fc50a,
  0x047fc50a,
  0x0d7fc50a,
  0x0c7fc50a,
  0x457fc50a,
  0x447fc50a,
  0x16e0050a,
  0x7ee0050a,
  0x4ee0050a,
  0x5ee0050a,
  0x06e0050a,
  0x46e0050a,
  0x163fc50a,
  0x7e3fc50a,
  0x4e3fc50a,
  0x5e3fc50a,
  0x063fc50a,
  0x463fc50a,
  0x35808580,
  0x11000100,
  0x35900000,
  0x13000100,
  0x358045ff,
  0x1080017f,
  0x35900000,
  0x1280017f,
  0x3480070e,
  0x2480070e,
  0x347fc70e,
  0x247fc70e,
  0x40c00010,
  0x40c00010,
  0x40bfff90,
  0x40bfff90,
  0x32400000,
  0x30400000,
  0x31400012,
  0x23400012,
  0x22400012,
  0x21400012,
  0x33400012,
  0x20400012,
  0x10400003,
  0x12400003,
  0x30c00012,
  0x33c00012,
  0x20c00012,
  0x23c00012,
  0x323fff80,
  0x303fff80,
  0x313fff92,
  0x233fff92,
  0x223fff92,
  0x213fff92,
  0x333fff92,
  0x203fff92,
  0x103fff83,
  0x123fff83,
  0x30bfff92,
  0x33bfff92,
  0x20bfff92,
  0x23bfff92,
  0x762b4000,
  0x766b4000,
  0x76a6c000,
  0x76e6c000,
  0x760b8000,
  0x764b8000,
  0x76870000,
  0x76c70000,
  0x3f000183,
  0x3f600183,
  0x3f1bc183,
  0x3f61c183,
  0x0fe00285,
  0x3fe00285,
  0x0fe7c285,
  0x3fe7c285,
  0x0f600306,
  0x0f6fc306,
  0x3e9bc387,
  0x3efbc387,
  0x3ebbc387,
  0x3edbc387,
  0x3e804387,
  0x3ee04387,
  0x3ea04387,
  0x3ec04387,
  0x00000000,
  0x00003fff,
  0x32800010,
  0x41800010,
  0x41000010,
  0x60800010,
  0x32ffff90,
  0x41ffff90,
  0x417fff90,
  0x60ffff90,
  0x42000012,
  0x43ffff92,
  0x40800000,
  0x40800001,
  0x04000101,
  0x01a00001,
  0x01a00081,
  0x01a00101,
  0x01a00181,
  0x01a00201,
  0x01a00281,
  0x01a00301,
  0x01a00381,
  0x01a00401,
  0x01a00481,
  0x01a00501,
  0x01a00581,
  0x01a00601,
  0x01a00681,
  0x01a00701,
  0x01a00781,
  0x01a00801,
  0x01a00881,
  0x01a00901,
  0x01a00981,
  0x01a00a01,
  0x01a00a81,
  0x01a00b01,
  0x01a00b81,
  0x01a00c01,
  0x01a00c81,
  0x01a00d01,
  0x01a00d81,
  0x01a00e01,
  0x01a00e81,
  0x01a00f01,
  0x01a00f81,
  0x01a01001,
  0x01a01081,
  0x01a01101,
  0x01a01181,
  0x01a01201,
  0x01a01281,
  0x01a01301,
  0x01a01381,
  0x01a01401,
  0x01a01481,
  0x01a01501,
  0x01a01581,
  0x01a01601,
  0x01a01681,
  0x01a01701,
  0x01a01781,
  0x01a01801,
  0x01a01881,
  0x01a01901,
  0x01a01981,
  0x01a01a01,
  0x01a01a81,
  0x01a01b01,
  0x01a01b81,
  0x01a01c01,
  0x01a01c81,
  0x01a01d01,
  0x01a01d81,
  0x01a01e01,
  0x01a01e81,
  0x01a01f01,
  0x01a01f81,
  0x01a02001,
  0x01a02081,
  0x01a02101,
  0x01a02181,
  0x01a02201,
  0x01a02281,
  0x01a02301,
  0x01a02381,
  0x01a02401,
  0x01a02481,
  0x01a02501,
  0x01a02581,
  0x01a02601,
  0x01a02681,
  0x01a02701,
  0x01a02781,
  0x01a02801,
  0x01a02881,
  0x01a02901,
  0x01a02981,
  0x01a02a01,
  0x01a02a81,
  0x01a02b01,
  0x01a02b81,
  0x01a02c01,
  0x01a02c81,
  0x01a02d01,
  0x01a02d81,
  0x01a02e01,
  0x01a02e81,
  0x01a02f01,
  0x01a02f81,
  0x01a03001,
  0x01a03081,
  0x01a03101,
  0x01a03181,
  0x01a03201,
  0x01a03281,
  0x01a03301,
  0x01a03381,
  0x01a03401,
  0x01a03481,
  0x01a03501,
  0x01a03581,
  0x01a03601,
  0x01a03681,
  0x01a03701,
  0x01a03781,
  0x01a03801,
  0x01a03881,
  0x01a03901,
  0x01a03981,
  0x01a03a01,
  0x01a03a81,
  0x01a03b01,
  0x01a03b81,
  0x01a03c01,
  0x01a03c81,
  0x01a03d01,
  0x01a03d81,
  0x01a03e01,
  0x01a03e81,
  0x01a03f01,
  0x01a03f81,
  0x01a00002,
  0x01a00402,
  0x01a00682,
  0x01a00782,
  0x01a00582,
  0x21a00083,
  0x21a00103,
  0x21a00383,
  0x21a00703,
  0x21a02003,
  0x01a00184,
  0x01a00204,
  0x01a00c04,
  0x01a00c84,
  0x01a00d84,
  0x01a00e84,
  0x01a00604,
  0x21a00805,
  0x21a00885,
  0x21a00905,
  0x21a00985,
  0x21a00a05,
  0x21a00a85,
  0x21a00b05,
  0x21a00b85,
  0x21a00d05,
  0x21a00e05,
  0x21a00f05,
  0x327ffe00,
  0x327fff80,
  0x32000580,
  0x00000000,
  0x41000003,
  0x60844a03,
  0x78614203,
  0x58614203,
  0x79614203,
  0x59614203,
  0x77e00488,
  0x77e6c488,
  0x77ffc488,
  0x28045064
};

#define COVERAGE_BIN_FILE	"spu/coverage.bin"


int main()
{
  int inst;
  union {
    unsigned int i;
    unsigned char c[4];
  } endian;
  unsigned int got;

  int failures;
  FILE *fp;

  failures = 0;
  endian.i = 1;


  fp = fopen(COVERAGE_BIN_FILE, "r");
  if (fp) {
    inst = 0;
    while (fread((void *)(&got), 4, 1, fp)) {
      if (4*inst > (int)sizeof(expected)) {
	fprintf(stderr, "ERROR: bin file contains more instructions than expected\n");
	return 1;
      }

      /* If this program is being run on a little endian processor, them
       * we must swizzle the instruction before comparing.
       */
      if (endian.c[0]) {
	got = (((got & 0x000000FF) << 24) | ((got & 0x0000FF00) << 8) | 
	       ((got & 0x00FF0000) >>  8) | ((got & 0xFF000000) >> 24));
      }

      if (got != expected[inst]) {
	printf("\tInstruction %d   Got 0x%08x   Expected 0x%08x\n", inst, got, expected[inst]);
	failures++;
      }
      inst++;
    }
    fclose(fp);
  } else {
    fprintf(stderr, "ERROR: Unable to open %s\n", COVERAGE_BIN_FILE);
    return 1;
  }

  if (failures) {
    printf("FAILED - %d instructions of %d bad\n", failures, inst);
  } else {
    printf("PASSED\n");
  }

  return (failures);
}
